import { FormKitTypeDefinition } from '@formkit/core';
import type { FormKitInputs } from '@formkit/inputs';
import { casts, createSection, label, outer } from '@formkit/inputs';
import SchemaComponent from 'primevue/password';
import { markRaw } from 'vue';
import { messages } from '../sections/messages';

export const PInputPassword: FormKitTypeDefinition = {
  type: 'input',
  schema: outer(
    label('$label'),
    createSection('input', () => ({
      $cmp: markRaw(SchemaComponent) as any,
      bind: '$attrs',
      props: {
        invalid: '$state.invalid',
        disabled: '$disabled',
        // name: '$node.name',
        // inputProps: {}
        onInput: '$handlers.DOMInput',
        onBlur: '$handlers.blur',
        modelValue: '$_value',
        inputId: '$id',
      },
    }))(),
    messages(),
  ),
  features: [casts],
  // schemaMemoKey: 'g2f31c24kjh',
};

declare module '@formkit/inputs' {
  // https://formkit.com/essentials/custom-inputs#typescript-support
  interface FormKitInputProps<Props extends FormKitInputs<Props>> {
    PInputPassword: {
      type: 'PInputPassword';
    };
  }
}
