import { FormKitTypeDefinition } from '@formkit/core';
import type { FormKitInputs } from '@formkit/inputs';
import { casts, createSection, label, outer } from '@formkit/inputs';
import SchemaComponent from 'primevue/inputtext';
import { markRaw } from 'vue';
import { messages } from '../sections/messages';

const cmpName = `SchemaComponent${SchemaComponent.name}`;

export const PInputText: FormKitTypeDefinition = {
  type: 'input',
  schema: outer(
    label('$label'),
    createSection('input', () => ({
      $cmp: cmpName,
      bind: '$attrs',
      props: {
        invalid: '$state.invalid',
        type: '$type',
        disabled: '$disabled',
        name: '$node.name',
        onInput: '$handlers.DOMInput',
        onBlur: '$handlers.blur',
        modelValue: '$_value',
        id: '$id',
      },
    }))(),
    messages(),
  ),
  library: {
    [cmpName]: markRaw(SchemaComponent),
  },
  features: [casts],
  // schemaMemoKey: 'g2f31c24kjh',
};

declare module '@formkit/inputs' {
  // https://formkit.com/essentials/custom-inputs#typescript-support
  interface FormKitInputProps<Props extends FormKitInputs<Props>> {
    PInputText: {
      type: 'PInputText';
    };
  }
}
